﻿#ifndef EQNETWORKTHREAD_H
#define EQNETWORKTHREAD_H

/*!
 *@file GameInfo.h
 *@author hxcan <caihuosheng@gmail.com>
 *@brief 表示游戏信息。
 */

#include "ExistQtGlobal.h" //EXIST_QT_EXPORT

#include "EqPreCompile.h" //QUrl

#include "ExistMessage.pb.h" //exist::ServicePublishMessage::ServiceProtocolType


/*!
 * \brief The GameInfo class 这个类表示一个游戏的信息。
 */
class EXIST_QT_EXPORT EqNetworkThread:public QThread
{
    Q_OBJECT

signals:
    void readedSocketData(char * buffer, int bufferLength, QHostAddress sender); //!<信号，读取到了数据。
    void serviceDiscovered(QString serviceName,quint16 servicePort,ServicePublishMessage::ServiceProtocolType serviceProtocolType); //!<信号，发现了服务。

public:
    ~EqNetworkThread(); //!<析构函数。
    void castData(string dataToCast); //!<发送数据。
    void run(); //!<运行。
    EqNetworkThread(); //!<默认构造函数。
    void publishService(QString LanServiceName,quint16 LanServicePort,exist::ServicePublishMessage::ServiceProtocolType LanServiceProtocolType); //!<发布服务。

private:
    void bindAndSetSocketOptionsForUnix(); //!<针对UNIX绑定及设置套接字选项。
    void bindAndSetSocketOptionsForWindows(); //!<针对Windows绑定及设置字选项。
    QUdpSocket dgs; //!<用于发送数据包的套接字。
    void bindAndSetSocketOptions(); //!<绑定并设置套接字选项。
    QHostAddress address; //!<组播组地址。
    void initializeMemberObjects(); //!<初始化成员对象。
    QUdpSocket socketObject; //!<用于组播通信的套接字。
    void readSocketData(); //!<尝试从网络读取数据。
    QTimer receiveTimer; //!<驱动读取过程的定时器。
    void connectSignals(); //!<连接信号槽。
    const quint16 MulticastPort=11500; //!<组播组的端口号。
    static EqNetworkThread * theSharedInstance; //!<共享实例。
}; //class EXISTQTSHARED_EXPORT GameInfo:public QObject

#endif // GAMEINFO_H
